// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"

#using <mscorlib.dll>
#include <tchar.h>

using namespace System;

__gc class Model
{
protected:
 String* firstName;
 String* lastName;
 String* alias;
 
public:
 __property String* get_Name()
 {
  String* modelName;

  if (this->alias
  && 0 < this->alias->Length)
   modelName = this->alias;
  else
  {
    modelName = String::Format("{0} {1}",
      this->firstName,
      this->lastName
      );
  }
  return modelName;
 }

 __property void set_FirstName(String* firstName)
 {
   this->firstName = firstName;
 }

 __property void set_LastName(String* lastName)
 {
   this->lastName = lastName;
 }

 __property void set_Alias(String* alias)
 {
   this->alias = alias;
 }
};

// This is the entry point for this application
int _tmain(void)
{
  Model* pM1 = new Model();
  pM1->FirstName = S"Laurie";
  pM1->LastName = S"Wallace";

  Model* pM2 = new Model();
  pM2->Alias = S"Nicole Sheridan";
  pM2->FirstName = S"Fake";
  pM2->LastName = S"Name";

  Console::WriteLine(pM1->Name);
  Console::WriteLine(pM2->Name);

  Console::ReadLine();

  return 0;
}